/*
*	Globals
*/

var g_eulaAgree = false;
var g_procDone = false;
var g_lastPage = 'startPage';
var g_tmpPage = 'startPage';
var g_selected = new Array();
var g_selectedCount = 0;
var g_selectedExtendCount = 0;
var g_extends = new Map();
var g_result = new Array();

function clearData(){
    g_eulaAgree = false;
    g_procDone = false;
    g_lastPage = 'startPage';
    g_tmpPage = 'startPage';
    g_selected = new Array();
    g_selectedCount = 0;
    g_selectedExtendCount = 0;
    g_extends = new Map();
    g_result = new Array();
    var count = document.getElementById('selectedCount');
    var confirm = document.getElementById('confirmCount');
    
	var removeBtnNA = document.getElementById('removeNA');
	var removeBtn = document.getElementById('remove');
	
	// start page
    var img = document.getElementById('checkboxStart');
   	var startBtn = document.getElementById('start');
	var startBtnNA = document.getElementById('startNA');
    img.src = 'img\\\\checkbox.png';
    startBtnNA.style.display = 'block';
    startBtn.style.display = 'none';
    // list page
	removeBtn.style.display = 'none';
	removeBtnNA.style.display = 'block';
    if(count)
        count.innerHTML="0";
    // confirm page
    if(confirm)
        confirm.innerHTML="0";
}

// checkbox for eula
function eularAgreeCheck(){
    var img = document.getElementById('checkboxStart');
	var startBtn = document.getElementById('start');
	var startBtnNA = document.getElementById('startNA');
		
    if(g_eulaAgree){
		img.src = 'img\\\\checkbox.png';
		g_eulaAgree = false;
		if ( startBtn )
		{
			startBtn.style.display = 'none';
		}
		
		if ( startBtnNA )
		{
			startBtnNA.style.display = 'block';
		}
    } else {        
		img.src = 'img\\\\appchecked.png';
		g_eulaAgree = true;
		if ( startBtn )
		{
			startBtn.style.display = 'block';
		}
		
		if ( startBtnNA )
		{
			startBtnNA.style.display = 'none';
		}
    }
}
function javascriptGetAppVersion() {
    var strHTML = document.getElementById('aboutPage').innerHTML;
    return strHTML;
}

// over remove selection checkbox
function checkboxOver(item){
    var img = document.getElementById(item.id + 'img');
    if(g_selected.hasOwnProperty(item.id)){
		// find item
		if ( g_selected[item.id] )
		{
			// was selected, do nothing			
		} else {
			img.src = 'img\\\\appcheckOver.png';
		}
    } else {
		// first time
		if(img)
			img.src = 'img\\\\appcheckOver.png';
	}
}

// out remove selection checkbox
function checkboxOut(item){
	var img = document.getElementById(item.id + 'img');
	if(g_selected.hasOwnProperty(item.id)){
		// find item
		if ( g_selected[item.id] )
		{
			// was selected, do nothing			
		} else {        
			img.src = 'img\\\\checkbox.png';
		}
	} else {
		// first time
		if(img)
			img.src = 'img\\\\checkbox.png';
	}
}

// checkbox for remove selection
function selectProduct(item){	
    var img = document.getElementById(item.id + 'img');
	var count = document.getElementById('selectedCount');
	var removeBtnNA = document.getElementById('removeNA');
	var removeBtn = document.getElementById('remove');

    if(g_selected.hasOwnProperty(item.id)){
		// find item
		if ( g_selected[item.id] )
		{
			// was selected, now check off
			img.src = 'img\\\\checkbox.png';
			g_selected[item.id] = false;
			
			// count decrement
			g_selectedCount--;
			
		} else {        
			// was not selected, now check on
			img.src = 'img\\\\appchecked.png';
			g_selected[item.id] = true;
			
			// count increment
			g_selectedCount++;
		}
    } else {
		// first time
		img.src = 'img\\\\appchecked.png';
		g_selected[item.id] = true;
		
		// count increment
		g_selectedCount++;
	}
	
	if (count)
		count.innerHTML=g_selectedCount+g_selectedExtendCount;
		
	if ( g_selectedCount+g_selectedExtendCount > 0 )
	{
		if ( removeBtn )
		{
			removeBtn.style.display = 'block';
		}
		
		if ( removeBtnNA )
		{
			removeBtnNA.style.display = 'none';
		}
	} else {
		if ( removeBtn )
		{
			removeBtn.style.display = 'none';
		}
		
		if ( removeBtnNA )
		{
			removeBtnNA.style.display = 'block';
		}
	}
}

// press start button
function startBtnPressed(){
    var img = document.getElementById('start');
    img.src = 'img\\\\StartButtonClick.png';
}

// release start button
function startBtnReleased(){
    var img = document.getElementById('start');
    img.src = 'img\\\\StartButton.png';
}

// press back button
function backBtnPressed(){
    var img = document.getElementById('back');
    img.src = 'img\\\\BackButtonClick.png';
}

// release start button
function backBtnReleased(){
    var img = document.getElementById('back');
    img.src = 'img\\\\BackButton.png';
}

// press reboot button
function rebootBtnPressed(){
    var img = document.getElementById('reboot');
    img.src = 'img/BackButtonClick.png';
}

// release reboot button
function rebootBtnReleased(){
    var img = document.getElementById('reboot');
    img.src = 'img/BackButton.png';
}

// press remove button
function removeBtnPressed(){
    var img = document.getElementById('remove');
    img.src = 'img\\\\RemoveButtonClick.png';
}

// release remove button
function removeBtnReleased(){
    var img = document.getElementById('remove');
    img.src = 'img\\\\RemoveButton.png';
}

// press save button
function saveBtnPressed(){
    var img = document.getElementById('save');
    img.src = 'img\\\\SaveButtonClick.png';
}

// release save button
function saveBtnReleased(){
    var img = document.getElementById('save');
    img.src = 'img\\\\SaveButton.png';
}

// press save button
function confirmBtnPressed(){
    var img = document.getElementById('confirm');
    img.src = 'img\\\\ConfirmButtonClick.png';
}

// release save button
function confirmBtnReleased(){
    var img = document.getElementById('confirm');
    img.src = 'img\\\\ConfirmButton.png';
}

// press submit button
function submitBtnPressed(){
    var img = document.getElementById('submit');
    img.src = 'img\\\\SubmitButtonClick.png';
}

// release submit button
function submitBtnReleased(){
    var img = document.getElementById('submit');
    img.src = 'img\\\\SubmitButton.png';
}

// press submit button
function backErrorBtnPressed(){
    var img = document.getElementById('backErr');
    img.src = 'img\\\\BackButtonClick.png';
}

// release submit button
function backErrorBtnReleased(){
    var img = document.getElementById('backErr');
    img.src = 'img\\\\BackButton.png';
}

// switch to other View page by name
function switchToView(pageToView){
	// hide the last page
	var mainContent = document.getElementById(g_tmpPage);
	if (mainContent)
	{
		mainContent.style.display = "none";
	}
    
	if ( pageToView == 'detectionPage' || pageToView == 'removalPage' || pageToView == 'sendingReportPage' )
    {
        document.getElementById('rptPage').onclick = new Function("return false;");
        //document.getElementById('rptPage').disabled = true;
        document.getElementById('rptPage').style.cursor = 'default';
    }
    else
    {
        document.getElementById('rptPage').onclick = new Function('switchToView("reportPage");');
        //document.getElementById('rptPage').disabled = false;
        document.getElementById('rptPage').style.cursor = 'pointer';
    }
	
	mainContent = document.getElementById(pageToView);
	if (mainContent)
	{
		mainContent.style.display = "block";
		g_tmpPage = pageToView;
	}
}

// switch to other View page by name and set last page
function switchToViewEx(pageToView,bStore){
    
	switchToView(pageToView);
	
	// Add custom scroll if needed
	//$(".nano").nanoScroller();
	nanoScroller();
    
    if(bStore==true || !bStore)
	    g_lastPage = pageToView;	
}


function nanoScroller(){
	if($.browser.msie){
		if($.browser.version >= "8.0")
			$(".nano").nanoScroller();
	}else{
		$(".nano").nanoScroller();
	}
}
// cancel report page
function cancelReport(){
	// clear content first
	var emailVal = document.getElementById('reportEmail');
	var descVal = document.getElementById('reportDesc');
	if ( emailVal && descVal )
	{	
		//emailVal.value = "";
		//descVal.value = "";
	}    
	// switch to last view
	var sendPage = document.getElementById("reportPage");
	if (sendPage)
	{
		sendPage.style.display = "none";
	}
	switchToView(g_lastPage);
}

// hide warning is necessary
function fixEmail(){
	var warnEmail = document.getElementById('emailWarn');
	if ( warnEmail && warnEmail.style.display == "block" )
	{
		warnEmail.style.display = "none";		
	}
}

function submitDone(){
	switchToView('reportDonePage');
}

// validate email and content and send report
function submitRpt(){
	var emailVal = document.getElementById('reportEmail');
	var descVal = document.getElementById('reportDesc');
	if (emailVal && descVal)
	{
		if (emailVal.value == "" ) {
			alert( "Please enter your email address." );
			return;
		} else {
			if ( !validateEmail(emailVal.value) )
			{
				// show warning and clear text
				var warnEmail = document.getElementById('emailWarn');
				if ( warnEmail )
				{
					warnEmail.style.display = "block"; 
				}
				emailVal.value = '';
				return;
			}
		}

		if (descVal.value == "" ) {
			alert( "Please enter your comment." );
			return;
		}
		
		var sendPage = document.getElementById("reportPage");
		if (sendPage)
		{
			sendPage.style.display = "none";
		}
		
		var sendEmail = emailVal.value;
		var sendDesc = descVal.value;
        var usrInf = "User email address: " + sendEmail + "\n" + "User Report:\n" + sendDesc + "\n";
        AppRemover.setAndSendIssue_(usrInf);
		//----> window.navigate('app:1005@issue::'+ sendEmail + '#$%!@' + sendDesc);		
		switchToView('sendingReportPage');
		waitProcessEnd("ISSUE_DONE",submitDone);
	}	
}

function reportDone(){
	// hide the report page
	switchToView(g_lastPage);
}

// regular expression to check email format
function validateEmail(email) { 
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}

function drawRingPct(ringHolder, textHolder, type)
{
	var size = 200,
	halfSize = size/2,	
	r = Raphael(ringHolder, size, size),
	R = 80,    
    param = {stroke: "#fff", "stroke-width": 15},
    html = document.getElementById(textHolder);
	                    
    // Custom Attribute
    r.customAttributes.arc = function (value, total, R) {
		var alpha = 360 / total * value,
		a = (90 - alpha) * Math.PI / 180,
		x = halfSize + R * Math.cos(a),
		y = halfSize - R * Math.sin(a),
		color = '#00a6dd',
		path;
		if (total == value) {
			path = [["M", halfSize, halfSize - R], ["A", R, R, 0, 1, 1, halfSize - 0.01, halfSize - R]];
		} else {
			path = [["M", halfSize, halfSize - R], ["A", R, R, 0, +(alpha > 180), 1, x, y]];
		}
		return {path: path, stroke: color};
	};

	var sec = r.path().attr(param).attr({arc: [0, 100, R]});

	function updateVal(value, total, R, hand) {
		hand.animate({arc: [value, total, R]}, 10, "linear");		
		html.innerHTML = (value < 10 ? "0" : "") + value + "%";
		html.style.color = '#7c7c7c';
	}
	
	// TODO: use the value pass in to update the val
	var d=0;	
	(function () {
		if ( d<100 ){
			updateVal(d, 100, R, sec);
			setTimeout(arguments.callee, 30);
			d++;
		} else {
			updateVal(d, 100, R, sec);
			if ( type == 'SCAN_DONE' )
			{			
				scanDone();
			} else if ( type == 'REMOVAL_DONE' )
			{
				removalDone();
			}
		}
	})();
}

function waitProcessEnd(type,func)
{        
	g_procDone = "";
	(function () {        
		if ( g_procDone == "" )
		{            
			setTimeout(arguments.callee, 1000);
            if(type=="SCAN_DONE"){
                
                if(AppRemover.isProcessDown()){
                
                    g_procDone = AppRemover.getProcessResult();
     
                   if(g_procDone=='') g_procDone="{}";
                }                              
            }
                else if(type=="REMOVE_DONE"){
     
                if(AppRemover.isProcessDown()){
                    g_procDone = AppRemover.getProcessResult();
                }
             else g_procDone="";
                
            } else if(type == "ISSUE_DONE"){
                
                g_procDone = AppRemover.isIssueDown();
                if(g_procDone==0) g_procDone="";                    
            }
            //----->g_procDone = window.external.CheckState(type);
			// for debug
			/*
			if(type == "SCAN_DONE")
				g_procDone = '{"count":6,"Security Applications" : [{"prodID": 2222, "vendor": "ALWIL Software","name":"avast! Internet Security",	"version": "8.1","icon":"img/icon/avast.ICO"},{	"prodID": 4444, "vendor": "Kaspersky Labs","name":	"Kaspersky PURE","version": "13.1","icon":"img/icon/Kaspersky.ICO"},{"prodID": 5555,"vendor": "F-Secure Corp.",	"name":	"F-Secure Anti-Virus",	"version": "12.2","icon":"img/icon/FSecure.ICO"}],"Public File Sharing" : [{"prodID": 6666, "vendor": "BitTorrent, Inc.","name":	"uTorrent ",	"version": "3.4","icon":"img/icon/utorrent.ICO"},{	"prodID": 7777,	"vendor": "BitComet",	"name":	"BitComet",	"version": "0.5","icon":"img/icon/BitComet.ICO"}, {"prodID": 8888, "vendor": "John Hoffman","name":	"BitTornado",	"version": "6.2","icon":"img/icon/bittorrent.ICO"}],"Browser Extensions" : [{	"prodID": 9999, "vendor": "Microsoft Inc.","name":	"Internet Explorer",	"version": "3.4","icon":"img/icon/ie.ICO","extensions":[{"prodID":90000,"vendor":"Microsoft Inc.","name":"Extension1","version":"1.1","icon":"img/icon/extend.ico"},{"prodID":90001,"vendor":"Microsoft Inc.","name":"Extension2","version":"1.2","icon":"img/icon/extend.ico"}]},{	"prodID": 1111,	"vendor": "Google Corp.",	"name":	"Google Chrome",	"version": "5.2","icon":"img/icon/chrome.ICO","extensions":[{"prodID":80000,"vendor":"google Inc.","name":"Extension1","version":"1.1","icon":"img/icon/extend.ico"},{"prodID":80001,"vendor":"Microsoft Inc.","name":"Extension2","version":"1.2","icon":"img/icon/extend.ico"}]}]}';
			*/
		}else{
			func();
		}
	})();    
}
/*
function waitProcessEnd(type,func)
{
	g_procDone = "";
	(function () {
		if ( type != g_procDone )
		{
			setTimeout(arguments.callee, 1000);
			g_procDone = type;
		}else{
			func();
		}
	})();
}
*/

// draw the percentage ring for detection page
function startScan() {
	//drawRingPct('pctRingDetect', 'pctDetectionText', 'SCAN_DONE');    
    AppRemover.creatThreadDetectedProduct();    
	waitProcessEnd('SCAN_DONE',scanDone);     
	////-----> window.navigate('app:1005@detect');
};

// switch to the detection page and start the percentage ring
function startDetection(){    
    /*
	// TODO: testing, remove me
	if ( g_eulaAgree )
	{
		alert('THIS IS FOR TESTING!!!\nThe user agrees to send report.\nNow call into C++ core for detection');
	} else {
		alert('THIS IS FOR TESTING!!!\nThe user does NOT agree to send report.\nNow call into C++ core for detection');
	}
	*/
	// switch to detection view
	switchToViewEx('detectionPage');

	startScan();	
}

function scanDone() {
	var testStr = g_procDone;
	var displayData = populateProduct(testStr);
	var el = document.getElementById('autoGenerate');
	if ( el )
	{
	    if(displayData.length > 0)
	    {
	        el.innerHTML = displayData;
	    }
	    else
	    {
	        el.innerHTML = '<div style="display:inline-block;text-align:center;font-family:Arial;color:#7C7C7C;font-size:18px;font-weight:bold;margin-top:50px;">No Applications Detected</center>';
	    }
	}

	$(".extensionList").hide();
	// switch to list view
	switchToViewEx('listPage');
	// check internet connect
    ///-------->
    /*
	var connect = window.external.CheckState("CHECK_CONNECTION");
	if(connect == "false")
	{
	    window.navigate('app:1005@alert::AppRemover requires an Internet connection to|remove applications.||Please connect to the Internet and try your|uninstallation again.');
	    clearData();
	    $('#listPage').hide();
	    $('#startPage').show();
	}
    */
    ///---------->
};

function startRemove() {	
	var jsonRet = '';
	
	var prodIDs = new Array();
	if ( g_selected )
	{
		for (var prop in g_selected)
		{
			if (g_selected[prop])
			{
				prodIDs.push(prop.substr(7));
			}
		}
	}
	if(g_extends)
	{
		var objs = g_extends.entrys();
		for(var o in objs){
			var value = objs[o].value;
			for (var prop in value)
			{
				prodIDs.push(value[prop].substr(7));
			}
		}
	}
	
	if ( prodIDs.length > 0 )
	{	
		var bFirst = true;
		jsonRet += '{"count":';
		jsonRet += prodIDs.length;
		jsonRet += ',"products":[';
		for (var prop in prodIDs) {
			if(bFirst)
				bFirst = false;
			else
				jsonRet += ',';
			jsonRet += '{"prodID":';
			jsonRet += prodIDs[prop];
			jsonRet += '}';
		}
		
		jsonRet += ']';
		jsonRet += '}';
		
		// TODO: testing, remove me
		// alert('THIS IS FOR TESTING!!!\n\nThe user wants to remove ' + prodIDs.length + ' products.\n\nNow call into C++ core for removal with JSON: \n\n'+ jsonRet);
        AppRemover.getUninstallProdus_(jsonRet);
		///----->window.navigate('app:1005@remove::'+jsonRet);
	}	
	
	// switch to detection view
	switchToViewEx('removalPage');
	//drawRingPct('pctRingRemoval', 'pctRemovalText', 'REMOVAL_DONE');
	waitProcessEnd('REMOVE_DONE',removalDone);
}

function removalDone() {
	// switch to list view
    if(g_procDone == "disconnect")
        switchToViewEx('startPage');

    else if(g_procDone == "failed")
	//    switchToViewEx('issuePage');
    
    {
        //----->window.navigate('app:1005@alert::AppRemover encountered an error while|attempting to remove the selected product(s).||Please use the "Report an Issue" link to send this|error to our support team!');
        //var json = AppRemover.getProcessResult();
     	clearData();
     	$('#removalPage').hide();
     	$('#reportPage').show();
        //switchToViewEx(issuePage);
    }
    else switchToViewEx('donePage');
}

function rebootMachine(){
	// TODO: testing, remove me
	//alert('THIS IS FOR TESTING!!!\nPass to C++ for rebooting.');
	window.navigate('app:1005@reboot');
}

function extendToolbarList(ext){
    var pid = $(ext).parent().attr('id');
    var down = document.getElementById(pid + 'Ext');
    
    $('#'+pid+'ExtList').slideToggle(200,nanoScroller);
    if(down.src.indexOf('down.png')>=0)
    {
        down.src="img\\\\downNA.png";
    }
    else
    {
        down.src="img\\\\down.png";
    }
}

// Populate the product html dynamically
function populateProduct(result){
	var obj = eval("(" + result + ")");
	var retStr = '';
	for (var key in obj) 
	{
        // is this the count
		if ( key == 'count' )
		{
			// the actual count is obj[count], do nothing now
		} else {
			// it must be category name
			var productList = obj[key];
			var sectionName = key;
			var bExtends = false;
			// Build category html
			retStr += buildCategoryHtml(sectionName);
			if ( sectionName == 'Browser Extensions' )
				bExtends = true;

			// Build product html             
			for (var i = 0; i < productList.length; i++) {
				var product = productList[i];
				g_result[product['prodID']] = productList[i];
				g_result[product['prodID']]['type'] = sectionName;
                //var iconpath = AppRemover.getProductIcon_IDS_versionS_(product['name'], product['prodID'], product['version']);
                g_result[product['prodID']]['icon'] = product['icon'];
				// Build extension html
				if(bExtends)
				{
					//var js = "$('#'+$(this).parent().attr('id')+'ExtList').slideToggle(200);";
					var extStr = '<div id="prodID_' + product['prodID'] + '" class="extensionBox" >';
					extStr += '<div onclick="extendToolbarList(this);">';
					extStr += buildExtensionBrowser(product['prodID'], product['vendor'], product['name'], product['version'], iconpath/*product['icon']*/);
					extStr += '</div>';
					extStr += '<div id="prodID_' + product['prodID'] + 'ExtList" alt="extensionList" class="extensionList">'
					for (var n = 0; n < product['extensions'].length; n++) {
						var ext = product['extensions'][n];
						if(n>0)	extStr += '<div class="dotLine"></div>';
						extStr += buildExtensionList(product['prodID'],ext['prodID'],ext['vendor'],ext['name'],ext['version'],ext['icon']);
					}
					extStr += '</div></div>';
					
					retStr += extStr;
				}else{
					retStr += buildProductHtml(product['prodID'], product['name'], product['version'], product['icon'], bExtends );
                }
			}
			// Closing tag
			retStr += '</div>';
		}		
	}
	return retStr;
}

/*
	sample output:
			<img id="prodID_9999Icon" alt="extensionIcon" src="img/icon/ie.ICO" class="extensionIcon">
			<div class="extensionBoxTitle">Select Extensions for Internet Explorer<span class="listExtensionSize">3.4</span></div>
			<img id="prodID_9999Ext" alt="extensionIcon" src="img/down.png" class="extensionButton">
*/
function buildExtensionBrowser(id,vendor,name,version,icon){
	var prodID = "prodID_" + id;
	var retStr = '<img id="' + prodID + 'Icon" alt="extensionIcon" src="' + icon + '" class="extensionIcon"/>';
	retStr += '<div id="' + prodID + 'Title" class="extensionBoxTitle">Select Extensions for ' + name + '<span class="listExtensionSize">' + version + '</span></div>';
	retStr += '<img id="' + prodID + 'Ext" alt="extensionIcon" src="img\\\\downNA.png" class="extensionButton"/>';
	return retStr;
}

/*
	sample output:
				<div class="extensionItem" id="prodID_90000" onmouseover="extendcheckboxOver(this)" onmousedown="" onmouseout="extendcheckboxOut(this)" onmouseup="" onclick="selectExtend(this)">
					<div class="extensionTitle">Extension1</div>
					<img id="prodID_90000img" alt="extensionCheck" src="img\\checkbox.png" class="extensionCheck">
				</div>
*/
function buildExtensionList(bID,eID,vendor,name,version,ico){
	var broID = "prodID_" + bID;
	var extID = "prodID_" + eID;
	var retStr = '<div class="extensionItem" id="' + extID + '" onmouseover="extendcheckboxOver(this)" onmousedown="" onmouseout="extendcheckboxOut(this)" onmouseup="" onclick="selectExtend(this)">';
	retStr += '<div class="extensionTitle" title="'+name+'">' + name + '</div>';
	retStr += '<img id="' + extID + 'img" alt="extensionCheck" src="img\\\\checkbox.png" class="extensionCheck"/>';
	retStr += '</div>';
	return retStr;    
}


/*
	sample output:
			<div class="listBoxContainer">
				<div class="listText">
					Security Applications
				</div>
*/
function buildCategoryHtml(value){
	var retStr = '<div class="listBoxContainer"><div class="listText">';
	retStr += value;
	retStr += '</div>';
	return retStr;
}

/*
	sample output:
			<div id="product1" class="listBox" onmouseover="checkboxOver(this)" onmousedown="" onmouseout="checkboxOut(this)" onmouseup="" onclick="selectProduct(this)">
				<img id="productIcon1" alt="productIcon" src="img/appIcon.png" class="productIcon"/>
				<div class="listBoxTitle">Norton Antispyware</div>
				<div class="listBoxSize">64.6MB</div>
				<img id="product1img" alt="removeCheck" src="img/checkbox.png" class="removeCheckBox" />
			</div>
*/
function buildProductHtml(productID, productName, productVersion, productIco){
	var retStr = '<div id="prodID_';
	retStr += productID;
	retStr += '" class="listBox" onmouseover="checkboxOver(this)" onmousedown="" onmouseout="checkboxOut(this)" onmouseup="" onclick="selectProduct(this)">';
	retStr += '<img id="prodID_';
	retStr += productID + 'Icon" alt="productIcon" src="'+productIco+'" class="productIcon"/>';
	retStr += '<div class="listBoxTitle" title="' + productName + '">';
	retStr += productName;
	retStr += '</div>';
	retStr += '<div class="listBoxSize">';
	retStr += productVersion;
	retStr += '</div>';
	retStr += '<img id="prodID_' + productID + 'img" alt="removeCheck" src="img\\\\checkbox.png" class="removeCheckBox" />';
	retStr += '</div>';
	return retStr;
}

function Map() {
	this.keys = new Array();
	this.data = new Object();

	this.put = function(key, value) {
		if(this.data[key] == null){
			this.keys.push(key);
		}
		this.data[key] = value;
	};

	this.get = function(key) {
		return this.data[key];
	};

	this.remove = function(key) {
		this.keys.remove(key);
		this.data[key] = null;
	};

	this.each = function(fn){
		if(typeof fn != 'function'){
			return;
		}
		var len = this.keys.length;
		for(var i=0;i<len;i++){
			var k = this.keys[i];
			fn(k,this.data[k],i);
		}
	};

	this.entrys = function() {
		var len = this.keys.length;
		var entrys = new Array(len);
		for (var i = 0; i < len; i++) {
			entrys[i] = {
				key : this.keys[i],
				value : this.data[this.keys[i]]
			};
		}
		return entrys;
	};

	this.isEmpty = function() {
		return this.keys.length == 0;
	};

	this.size = function() {
		return this.keys.length;
	};
}

function indexOf(a,e){
  for(var i=0,j; j=a[i]; i++){
    if(j==e){return i;}
  }
  return -1;
}

function extendcheckboxOver(item) {
	var pid = $(item).parent().attr('id');
	var key = pid.substring(0,pid.search('ExtList'));
    var img = document.getElementById(item.id + 'img');
	var list = g_extends.get(key);
    if(list){
		// find item
		if ( indexOf(list,item.id)>=0 )
		{
			// was selected, do nothing			
		} else {        
			img.src = 'img\\\\appcheckOver.png';
		}
    } else {
		// first time
		img.src = 'img\\\\appcheckOver.png';
	}
}

function extendcheckboxOut(item){
	var pid = $(item).parent().attr('id');
	var key = pid.substring(0,pid.search('ExtList'));
    var img = document.getElementById(item.id + 'img');
	var list = g_extends.get(key);
    if(list){
		// find item
		if ( indexOf(list,item.id)>=0 )
		{
			// was selected, do nothing			
		} else {        
			img.src = 'img\\\\checkbox.png';
		}
	} else {
		// first time
		img.src = 'img\\\\checkbox.png';
	}
}

function selectExtend(item){
	var pid = $(item).parent().attr('id');
	var key = pid.substring(0,pid.search('ExtList'));
    var img = document.getElementById(item.id + 'img');
	var list = g_extends.get(key);

	var count = document.getElementById('selectedCount');

	if(!list)
	{
		list = new Array();
		g_extends.put(key,list);
	}
	var index = indexOf(list,item.id);
	if(index>=0){
		// find item was selected, now check off
		img.src = 'img\\\\checkbox.png';
		list.splice(index,1);
		
		// count decrement
		g_selectedExtendCount--;
	}else{
		// was not selected, now check on
		img.src = 'img\\\\appchecked.png';
		list.push(item.id);
		
		// count increment
		g_selectedExtendCount++;
	}

	if (count)
		count.innerHTML=g_selectedCount+g_selectedExtendCount;

	var removeBtnNA = document.getElementById('removeNA');
	var removeBtn = document.getElementById('remove');
	if ( g_selectedCount+g_selectedExtendCount > 0 )
	{
		if ( removeBtn )
		{
			removeBtn.style.display = 'block';
		}
		
		if ( removeBtnNA )
		{
			removeBtnNA.style.display = 'none';
		}
	} else {
		if ( removeBtn )
		{
			removeBtn.style.display = 'none';
		}
		
		if ( removeBtnNA )
		{
			removeBtnNA.style.display = 'block';
		}
	}
	
	var title = document.getElementById(key + 'Title');
	var obj = getProductJson(key);
	if(!list || list.length==0)
        title.innerHTML = 'Select Extensions for ' + obj['name'] + ' <SPAN class="listExtensionSize">' + obj['version'] + '</SPAN>';
    else
        title.innerHTML = list.length + ' Selected for ' + obj['name'] + ' <SPAN class="listExtensionSize">' + obj['version'] + '</SPAN>';
}

function saveExtend(){
	var objs = g_extends.entrys();
	for(var o in objs){
		var key = objs[o].key;
		var value = objs[o].value;

		if(value.length>0){
			var count = document.getElementById(key+'count');
			count.innerHTML=value.length;
		}else{
			var count = document.getElementById(key+'count');
			count.innerHTML=0;
		}
	}
	
	var removeBtnNA = document.getElementById('removeNA');
	var removeBtn = document.getElementById('remove');
	if ( g_selectedCount+g_selectedExtendCount > 0 )
	{
		if ( removeBtn )
		{
			removeBtn.style.display = 'block';
		}
		
		if ( removeBtnNA )
		{
			removeBtnNA.style.display = 'none';
		}
	} else {
		if ( removeBtn )
		{
			removeBtn.style.display = 'none';
		}
		
		if ( removeBtnNA )
		{
			removeBtnNA.style.display = 'block';
		}
	}
	$(".ExtList").show();
	switchToViewEx('listPage');
}

// Populate the product html dynamically
function populateConfirm(){
	var sHtml = '';
	// build av
	sHtml += buildProductConfirm();
	// build toolbar
	sHtml += buildExtensionConfirm();

	var el = document.getElementById('autoGenerateConfirm');
	if ( el )
	{
		el.innerHTML = sHtml;
	}
}

function getProductJson(prodID)
{
	for (var key in g_result) 
	{
		if("prodID_" + key ==prodID)
		{
			return g_result[key];
		}
	}
}
function getExtensionJson(array, prodID)
{
	for (var i in array)
	{
		var ext = array[i]
		if("prodID_" + ext['prodID'] ==prodID)
		{
			return ext;
		}
	}
}
/* sample output:
	<div class="listBoxContainer">
		<div class="listText">Browser Extensions</div>
		<div id="prodID_9999" class="extensionBox" onmouseover="checkboxOver(this)" onmousedown="" onmouseout="checkboxOut(this)" onmouseup="" onclick="selectProduct(this)">
			<img id="prodID_9999Icon" alt="extensionIcon" src="img/icon/ie.ICO" class="extensionIcon">
			<div class="listBoxTitle">Select Extensions for Internet Explorer<span class="listExtensionSize">3.4</span></div>
			<img id="prodID_9999Ext" alt="extensionIcon" src="img/down.png" class="extensionButton">
			<div id="prodID_9999ExtList" alt="extensionList" class="extensionList">
				<div class="extensionItem" id="prodID_90000" onmouseover="extendcheckboxOver(this)" onmousedown="" onmouseout="extendcheckboxOut(this)" onmouseup="" onclick="selectExtend(this)">
					<div class="extensionTitle">Extension1</div>
					<img id="prodID_90000img" alt="extensionCheck" src="img\\checkbox.png" class="extensionCheck">
				</div>
				<div class="dotLine"></div>
				<div class="extensionItem" id="prodID_90001" onmouseover="extendcheckboxOver(this)" onmousedown="" onmouseout="extendcheckboxOut(this)" onmouseup="" onclick="selectExtend(this)">
					<div class="extensionTitle">Extension2</div>
					<img id="prodID_90001img" alt="extensionCheck" src="img\\checkbox.png" class="extensionCheck">
				</div>
			</div>
		</div>
	</div>
*/
function buildExtensionConfirm(){
	var sHtml = '';
	var objs = g_extends.entrys();
	for(var o in objs){
		var key = objs[o].key;
		var value = objs[o].value;
		if(value.length>0){
			var obj = getProductJson(key);
			// build head
			var js = "$('#'+$(this).parent().attr('id')+'ExtList').slideToggle(200,nanoScroller);";
			sHtml += '<div id="' + key +  '" class="extensionBox" >';
			sHtml += '<img id="' + key + 'Icon" alt="extensionIcon" src="' + obj['icon'] + '" class="extensionIcon"/>';
			sHtml += '<div class="extensionBoxTitle">Extensions for ' + obj['name'] + '<span class="listExtensionSize">' + obj['version'] + '</span></div>';
			sHtml += '<div id="' + key + 'ExtList" alt="extensionList" class="extensionList">'
			var n = 0;
			for(var i in value){
				var extID = value[i];
				var ext = getExtensionJson(obj['extensions'],extID);
				if(n++>0)	sHtml += '<div class="dotLine"></div>';
				sHtml += '<div class="extensionItem">';
				sHtml += '<div class="extensionTitle" title="' + ext['name'] + '">' + ext['name'] + '</div>';
				sHtml += '<img src="img\\\\right.png" class="extensionCheck"/>';
				sHtml += '</div>';
			}
			sHtml += '</div></div>';
		}
	}
	if(sHtml.length>0)
	{
		sHtml='<div class="listBoxContainer"><div class="listText">Browser Extensions</div>'+sHtml+'</div>';
	}
	return sHtml;
}

/*
	sample output:
			<div class="listText">Security Applications</div>
			<div id="prodID_2222" class="listBox">
				<img id="prodID_2222Icon" alt="productIcon" src="img/icon/avast.ico" class="productIcon">
				<div class="listBoxTitle">Yiyi's Fishing Worm Killer</div>
				<div class="listBoxSize">0.2</div>
			</div>
*/
function buildProductConfirm(){
	var spHtml='',fpsHtml='';
	for(var k in g_selected){
		if(g_selected[k]){
			var obj = getProductJson(k)
			var html = '';
			if(obj['type']=="Browser Extensions")continue;
			
			html+="<div id='" + k + "' class='listBox'>";
			html+="<img id='" + k + "Icon' alt='productIcon' src='" + obj['icon'] + "' class='productIcon'/>";
			html+="<div class='listBoxTitle'>" + obj['name'] + "</div>";
			html+="<div class='listBoxSize'>" + obj['version'] + "</div>";
			html+="<img src='img\\\\right.png' class='confirmImg'/>";
			html+="</div>";
			
			if(obj['type']=="Public File Sharing") fpsHtml += html;
			if(obj['type']=="Security Applications") spHtml += html;
		}
	}

	if(spHtml.length>0)
		spHtml = '<div class="listBoxContainer"><div class="listText">Security Applications</div>' + spHtml + '</div></div>';
	if(fpsHtml.length>0)
		fpsHtml = '<div class="listBoxContainer"><div class="listText">Public File Sharing</div>' + fpsHtml + '</div></div>';
                  
	return spHtml + fpsHtml;
}

function gotoConfirm(){
	var confirmCount = document.getElementById('confirmCount');
	var confirmBtn = document.getElementById('confirm');
	confirmCount.innerHTML = g_selectedCount+g_selectedExtendCount;
	if ( g_selectedCount+g_selectedExtendCount > 0 )
	{
	    confirmBtn.style.display = 'block';
	}else{
	    confirmBtn.style.display = 'none';
	}
	
	populateConfirm();
	$(".ExtList").show();
	switchToViewEx('listConfirmPage');
}